"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.creatController = void 0;
const crud_1 = require("@crudjs/crud");
const curd_plus_base_decorator_1 = require("../decorators/curd-plus-base.decorator");
const swagger_1 = require("@nestjs/swagger");
function creatController(EntityClass, options = {}) {
    var _a;
    let Controller = class Controller {
        constructor(service) {
            this.service = service;
        }
        createManyBase(req, dto) {
            return this.service.createMany(req, dto);
        }
        createOneBase(req, dto) {
            return this.service.createOne(req, dto);
        }
        deleteOneBase(req) {
            return this.service.deleteOne(req);
        }
        recoverOneBase(req) {
            return this.service.recoverOne(req);
        }
        replaceOneBase(req, dto) {
            return this.service.replaceOne(req, dto);
        }
        updateOneBase(req, dto) {
            return this.service.updateOne(req, dto);
        }
        getManyBase(req) {
            return this.service.getMany(req);
        }
        getOneBase(req) {
            return this.service.getOne(req);
        }
    };
    __decorate([
        (0, swagger_1.ApiResponse)({ type: Object }),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], Controller.prototype, "getOneBase", null);
    Controller = __decorate([
        (0, curd_plus_base_decorator_1.CrudPlusBase)(),
        __metadata("design:paramtypes", [crud_1.CrudService])
    ], Controller);
    (_a = options.exclude) === null || _a === void 0 ? void 0 : _a.forEach((item) => delete Controller.prototype[item]);
    return Controller;
}
exports.creatController = creatController;
//# sourceMappingURL=creat-controller.factory.js.map