"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.R2 = void 0;
const crud_1 = require("@crudjs/crud/lib/crud");
const constants_1 = require("../constants");
class R2 {
    static setPlusBase(metadata, target) {
        crud_1.R.set(constants_1.CRUD_PLUS_BASE_MD, metadata, target);
    }
    static getPlusBaseMetadata(target) {
        return crud_1.R.get(constants_1.CRUD_PLUS_BASE_MD, target) || {};
    }
    static setNoMergeBase(props, func) {
        crud_1.R.set(constants_1.NO_MERGE_BASE_MD, props, func);
    }
    static setBaseMethodMarker(target) {
        crud_1.R.set(constants_1.IS_BASE_METHOD_MD, true, target);
    }
    static getIsBaseMethod(target) {
        return crud_1.R.get(constants_1.IS_BASE_METHOD_MD, target);
    }
}
exports.R2 = R2;
//# sourceMappingURL=reflection-plus.helper.js.map